"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _color = require("../color");
var _util = require("../util");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const Gradient = ({
  colors,
  children,
  direction = 'to right',
  type,
  prefixCls
}) => {
  const gradientColors = (0, _react.useMemo)(() => colors.map((color, idx) => {
    let result = (0, _util.generateColor)(color);
    if (type === 'alpha' && idx === colors.length - 1) {
      result = new _color.Color(result.setA(1));
    }
    return result.toRgbString();
  }).join(','), [colors, type]);
  return /*#__PURE__*/_react.default.createElement("div", {
    className: `${prefixCls}-gradient`,
    style: {
      position: 'absolute',
      inset: 0,
      background: `linear-gradient(${direction}, ${gradientColors})`
    }
  }, children);
};
var _default = exports.default = Gradient;